using System;
using System.Data;
using System.Data.OleDb;
using System.Web.UI.WebControls;
using Telerik.WebControls;

namespace Telerik.GridExamplesCSharp.Programming.WebMail
{
    public partial class GridsInteraction : System.Web.UI.Page
    {
        private string CurrFolder
        {
            get
            {
                object res = this.ViewState["CurrFolder"];
                if (res != null)
                {
                    return (string)res;
                }

                return "Inbox";
            }
            set
            {
                this.ViewState["CurrFolder"] = value;
                this.ViewState["Mails"] = null;
            }
        }

        private DataTable Mails
        {
            get
            {
                object res = this.ViewState["Mails"];
                if (res != null)
                {
                    return (DataTable)res;
                }

                DataTable table = this.GetDataTable("SELECT * FROM Mails Where FolderName = '" + this.CurrFolder + "'");
                this.ViewState["Mails"] = table;
                return table;
            }
        }

        private void RadGrid1_NeedDataSource(object source, Telerik.WebControls.GridNeedDataSourceEventArgs e)
        {
            RadGrid1.DataSource = this.Mails;
        }

        protected void ToggleRowSelection(object sender, EventArgs e)
        {
            ((sender as CheckBox).Parent.Parent as GridItem).Selected = (sender as CheckBox).Checked;
        }

        #region Web Form Designer generated code
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);
        }

        ///		Required method for Designer support - do not modify
        ///		the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.FoldersTree.NeedDataSource += new Telerik.WebControls.GridNeedDataSourceEventHandler(this.FoldersTree_NeedDataSource);
            this.FoldersTree.DetailTableDataBind += new Telerik.WebControls.GridDetailTableDataBindEventHandler(this.FoldersTree_DetailTableDataBind);
            this.FoldersTree.SelectedIndexChanged += new System.EventHandler(this.FoldersTree_SelectedIndexChanged);
            this.RadGrid1.NeedDataSource += new Telerik.WebControls.GridNeedDataSourceEventHandler(this.RadGrid1_NeedDataSource);
            this.RadGrid1.ItemCommand += new GridCommandEventHandler(RadGrid1_ItemCommand);
            this.RadGrid1.ItemCreated += new GridItemEventHandler(RadGrid1_ItemCreated);
            this.PreRender += new System.EventHandler(this.grid_PreRender);
        }
        #endregion

        private void FoldersTree_NeedDataSource(object source, Telerik.WebControls.GridNeedDataSourceEventArgs e)
        {
            FoldersTree.DataSource = GetDataTable("SELECT * FROM Folders");
        }

        private void FoldersTree_DetailTableDataBind(object source, Telerik.WebControls.GridDetailTableDataBindEventArgs e)
        {
            GridDataItem parentItem = e.DetailTableView.ParentItem as GridDataItem;

            if (e.DetailTableView.DataMember == "SubFolders")
            {
                e.DetailTableView.DataSource = GetDataTable("SELECT * FROM SubFolders where ParentFolder = '" + parentItem["FolderName"].Text + "'");
            }
        }

        private void grid_PreRender(object sender, System.EventArgs e)
        {
            if (!IsPostBack)
            {
                FoldersTree.Items[3].Selected = true;
            }
        }

        private void FoldersTree_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            this.CurrFolder = (FoldersTree.SelectedItems[0].Cells[3].Controls[0] as LinkButton).Text;
            RadGrid1.CurrentPageIndex = 0;
            RadGrid1.Rebind();
        }

        private DataTable GetDataTable(String queryString)
        {
            OleDbConnection MyOleDbConnection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + Server.MapPath("~/App_Data/Mail.mdb"));
            OleDbDataAdapter MyOleDbDataAdapter = new OleDbDataAdapter();
            MyOleDbDataAdapter.SelectCommand = new OleDbCommand(queryString, MyOleDbConnection);

            DataTable myDataTable = new DataTable();
            MyOleDbConnection.Open();
            try
            {
                MyOleDbDataAdapter.Fill(myDataTable);
            }
            finally
            {
                MyOleDbConnection.Close();
            }

            return myDataTable;
        }

        protected override void RaisePostBackEvent(System.Web.UI.IPostBackEventHandler sourceControl, string eventArgument)
        {
            base.RaisePostBackEvent(sourceControl, eventArgument);
            if (sourceControl == RadGrid1)
            {
                if (eventArgument == "Rebind" && FoldersTree.SelectedItems[0].Cells[3].Controls.Count > 0)
                {
                    this.CurrFolder = (FoldersTree.SelectedItems[0].Cells[3].Controls[0] as LinkButton).Text;
                    RadGrid1.CurrentPageIndex = 0;
                    RadGrid1.Rebind();
                }

            }
            if (sourceControl == FoldersTree)
            {
                if (eventArgument == "Rebind")
                {
                    this.CurrFolder = "Inbox";
                    FoldersTree.Items[3].Selected = true;
                }
            }
        }

        private void RadGrid1_ItemCommand(object source, GridCommandEventArgs e)
        {
            if (e.CommandName == "ChangeFlag")
            {
                DataRow[] changedRows = this.Mails.Select("MailID = " + e.Item.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["MailID"]);
                if (changedRows.Length != 1)
                {
                    e.Canceled = true;
                    return;
                }

                changedRows[0].BeginEdit();
                try
                {
                    changedRows[0]["Flagged"] = Convert.ToBoolean(changedRows[0]["Flagged"]) ? false : true;
                    changedRows[0].EndEdit();
                }
                catch (Exception ex)
                {
                    changedRows[0].CancelEdit();
                    e.Canceled = true;
                }
                e.Item.OwnerTableView.Rebind();
            }
        }

        private void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                e.Item.ForeColor = (Convert.ToBoolean(e.Item.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["Flagged"])) ? System.Drawing.Color.Red : System.Drawing.Color.Empty;
            }
        }
    }
}
